/*
  File autogenerated by gengetopt version 2.12.2
  generated with the following command:
  gengetopt -u --conf-parser --file-name=pob-ogg.cmdline 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "pob-ogg.cmdline.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->config_file_given = 0 ;
  args_info->hostname_given = 0 ;
  args_info->server_port_given = 0 ;
  args_info->loglevel_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->config_file_arg = NULL;
  args_info->hostname_arg = gengetopt_strdup ("localhost");
  args_info->server_port_arg = 8000 ;
  args_info->loglevel_arg = 5 ;
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Usage: %s [OPTIONS]... [FILES]...\n", CMDLINE_PARSER_PACKAGE);
  printf("\n");
  printf("%s\n","  -h, --help                  Print help and exit");
  printf("%s\n","  -V, --version               Print version and exit");
  printf("%s\n","  -c, --config_file=filename  default  ~/.paraslash/pob-ogg.conf");
  printf("%s\n","  -i, --hostname=STRING       ip or host  (default=`localhost')");
  printf("%s\n","  -p, --server_port=INT       port to connect  (default=`8000')");
  printf("%s\n","  -l, --loglevel=level        set loglevel (0-6)  (default=`5')");
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->config_file_arg)
    {
      free (args_info->config_file_arg); /* free previous argument */
      args_info->config_file_arg = 0;
    }
  if (args_info->hostname_arg)
    {
      free (args_info->hostname_arg); /* free previous argument */
      args_info->hostname_arg = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "config_file",	1, NULL, 'c' },
        { "hostname",	1, NULL, 'i' },
        { "server_port",	1, NULL, 'p' },
        { "loglevel",	1, NULL, 'l' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVc:i:p:l:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'c':	/* default  ~/.paraslash/pob-ogg.conf.  */
          if (local_args_info.config_file_given)
            {
              fprintf (stderr, "%s: `--config_file' (`-c') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->config_file_given && ! override)
            continue;
          local_args_info.config_file_given = 1;
          args_info->config_file_given = 1;
          if (args_info->config_file_arg)
            free (args_info->config_file_arg); /* free previous string */
          args_info->config_file_arg = gengetopt_strdup (optarg);
          break;

        case 'i':	/* ip or host.  */
          if (local_args_info.hostname_given)
            {
              fprintf (stderr, "%s: `--hostname' (`-i') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->hostname_given && ! override)
            continue;
          local_args_info.hostname_given = 1;
          args_info->hostname_given = 1;
          if (args_info->hostname_arg)
            free (args_info->hostname_arg); /* free previous string */
          args_info->hostname_arg = gengetopt_strdup (optarg);
          break;

        case 'p':	/* port to connect.  */
          if (local_args_info.server_port_given)
            {
              fprintf (stderr, "%s: `--server_port' (`-p') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->server_port_given && ! override)
            continue;
          local_args_info.server_port_given = 1;
          args_info->server_port_given = 1;
          args_info->server_port_arg = strtol (optarg,&stop_char,0);
          break;

        case 'l':	/* set loglevel (0-6).  */
          if (local_args_info.loglevel_given)
            {
              fprintf (stderr, "%s: `--loglevel' (`-l') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->loglevel_given && ! override)
            continue;
          local_args_info.loglevel_given = 1;
          args_info->loglevel_given = 1;
          args_info->loglevel_arg = strtol (optarg,&stop_char,0);
          break;


        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (check_required)
    {
    }

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;

      args_info->inputs_num = argc - optind ;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ;
    }

  return 0;

failure:
  return (EXIT_FAILURE);
}

#define CONFIGPARSERBUFSIZE 256
#define ADDITIONAL_ERROR " in configuration file "

#define CONF_FILE_LINES 256
#define CONF_FILE_STRING (CONFIGPARSERBUFSIZE+3)
/* 3 is for "--" and "=" */

typedef char buffer_line_t[CONF_FILE_LINES];

buffer_line_t
my_argv[CONF_FILE_STRING];

int
cmdline_parser_configfile (char * const filename, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  FILE* file;
  char linebuf[CONFIGPARSERBUFSIZE];
  int line_num = 0;
  int len, i, result;
  int fnum;
  char fopt[CONFIGPARSERBUFSIZE], farg[CONFIGPARSERBUFSIZE];
  char *str_index, *str_index2;
  int next_token;
  int my_argc = 0;
  char **my_argv_arg;
  char *additional_error;

  strcpy (my_argv[0], CMDLINE_PARSER_PACKAGE);
  for (i = 1; i < CONF_FILE_LINES; ++i)
    my_argv[i][0] = '\0';

  if ((file = fopen(filename, "r")) == NULL)
    {
      fprintf (stderr, "%s: Error opening configuration file '%s'\n",
               CMDLINE_PARSER_PACKAGE, filename);
      exit (EXIT_FAILURE);
    }

  while ((fgets(linebuf, CONFIGPARSERBUFSIZE, file)) != NULL)
    {
      ++line_num;
      len = strlen(linebuf);
      if (len > (CONF_FILE_STRING-1))
        {
          fprintf (stderr, "%s:%s:%d: Line too long in configuration file\n",
                   CMDLINE_PARSER_PACKAGE, filename, line_num);
          exit (EXIT_FAILURE);
        }

      /* read the option */
      fnum = sscanf (linebuf, "%s", fopt);

      if (fnum < 0)
        continue; /* blank line */

      if (fopt[0] == '#')
        continue; /* Line was a comment */

      str_index = strchr (fopt, '=');
      if (str_index)
        {
          next_token = (str_index - fopt);
          fopt[next_token] = '\0';
        }
      else
        next_token = strlen (fopt);

      next_token += strspn (&linebuf[next_token], " \t=");
      str_index = strchr (&linebuf[next_token], '\"');

      if (linebuf[next_token] != '\"' && str_index)
        {
          fprintf
            (stderr,
             "%s:%s:%d: malformed string in configuration file\n",
             CMDLINE_PARSER_PACKAGE, filename, line_num);
          exit (EXIT_FAILURE);
        }

      if (str_index)
        {
          str_index2 = strchr (str_index + 1, '\"');
          if (! str_index2)
            {
              fprintf
                (stderr,
                 "%s:%s:%d: unterminated string in configuration file\n",
                 CMDLINE_PARSER_PACKAGE, filename, line_num);
              exit (EXIT_FAILURE);
            }

          strncpy (farg, str_index + 1, str_index2 - str_index - 1);
          farg[str_index2 - str_index - 1]='\0';
          ++fnum;
        }
      else
        if (sscanf (&linebuf[next_token], "%s", farg) > 0)
          ++fnum;

      if (fnum > 0)
        {
          int _fopt_len, farg_len;

          ++my_argc;

          if (fnum == 2) /* does it have an argument? */
            farg_len = strlen (farg);
          else
            farg_len = 0;

          if (strlen(fopt) == 1)
            _fopt_len = 1; /* for '-' */
          else
            _fopt_len = (farg_len ? 3 : 2); /* 2 for '--' and 1 for '=' */

          if (_fopt_len > 1)
            strcat (my_argv[my_argc], "--");
          else
            strcat (my_argv[my_argc], "-");

          strcat (my_argv[my_argc], fopt);

          if (farg_len)
            {
              if (_fopt_len > 1)
                strcat (my_argv[my_argc], "=");
              strcat (my_argv[my_argc], farg);
            }
        }
    } /* while */
  fclose(file); /* No error checking on close */

  ++my_argc; /* for program name */
  my_argv_arg = (char **) malloc((my_argc+1) * sizeof(char *));
  for (i = 0; i < my_argc; ++i)
    my_argv_arg[i] = my_argv[i];
  my_argv_arg[my_argc] = 0;

  additional_error = (char *)malloc(strlen(filename) + strlen(ADDITIONAL_ERROR) + 1);
  strcpy (additional_error, ADDITIONAL_ERROR);
  strcat (additional_error, filename);
  result =
    cmdline_parser_internal (my_argc, my_argv_arg, args_info, override, initialize, check_required, additional_error);

  free (additional_error);
  free (my_argv_arg);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}
